---
title: ReadableStreamDefaultController
slug: Web/API/ReadableStreamDefaultController
tags:
  - API
  - Fetch
  - Interface
  - ReadableStreamDefaultController
  - Reference
  - Streams
---
<p>{{APIRef("Streams")}}</p>

<p><span class="seoSummary">The <strong><code>ReadableStreamDefaultController</code></strong> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> represents a controller allowing control of a {{domxref("ReadableStream")}}'s state and internal queue. Default controllers are for streams that are not byte streams. </span></p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dd>None. <code>ReadableStreamDefaultController</code> instances are created automatically during <code>ReadableStream</code> construction.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("ReadableStreamDefaultController.desiredSize")}} {{readonlyInline}}</dt>
 <dd>Returns the desired size required to fill the stream's internal queue.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("ReadableStreamDefaultController.close()")}}</dt>
 <dd>Closes the associated stream.</dd>
 <dt>{{domxref("ReadableStreamDefaultController.enqueue()")}}</dt>
 <dd>Enqueues a given chunk in the associated stream.</dd>
 <dt>{{domxref("ReadableStreamDefaultController.error()")}}</dt>
 <dd>Causes any future interactions with the associated stream to error.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following simple example, a custom <code>ReadableStream</code> is created using a constructor (see our <a href="https://mdn.github.io/dom-examples/streams/simple-random-stream/">Simple random stream example</a> for the full code). The <code>start()</code> function generates a random string of text every second and enqueues it into the stream. A <code>cancel()</code> function is also provided to stop the generation if {{domxref("ReadableStream.cancel()")}} is called for any reason.</p>

<p>Note that a {{domxref("ReadableStreamDefaultController")}} object is provided as the parameter of the <code>start()</code> and <code>pull()</code> functions.</p>

<p>When a button is pressed, the generation is stopped, the stream is closed using {{domxref("ReadableStreamDefaultController.close()")}}, and another function is run, which reads the data back out of the stream.</p>

<pre class="brush: js">const stream = new ReadableStream({
  start(controller) {
    interval = setInterval(() =&gt; {
      let string = randomChars();

      // Add the string to the stream
      controller.enqueue(string);

      // show it on the screen
      let listItem = document.createElement('li');
      listItem.textContent = string;
      list1.appendChild(listItem);
    }, 1000);

    button.addEventListener('click', function() {
      clearInterval(interval);
      fetchStream();
      controller.close();
    })
  },
  pull(controller) {
    // We don't really need a pull in this example
  },
  cancel() {
    // This is called if the reader cancels,
    // so we should stop generating strings
    clearInterval(interval);
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#rs-default-controller-class','ReadableStreamDefaultController')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ReadableStreamDefaultController")}}</p>
</div>
